from com.zms.captcha.CaptchasDotNet import CaptchasDotNet
from com.zms.captcha.PILCaptcha import *
from com.zms.captcha.reCaptcha import *

class C_Captcha_Basic:
	def __init__(self, zms_context):
		self.id						= None
		
		self.zms_context	= zms_context
		self.zms_lang			= self.zms_context.REQUEST.get('lang', self.zms_context.getPrimaryLanguage())
		
	def GetContent(self):
		return None
	
	def GetID(self):
		return self.id
	
	def IsCodeValid(self, code):
		return False
	


class C_Captcha_Dot_Net(C_Captcha_Basic):
	def __init__(self, zms_context):
		C_Captcha_Basic.__init__(self, zms_context)
		
		temp_client		= zms_context.attr_captcha.getObjProperty('captchaClient', zms_context.REQUEST)
		temp_secret		= zms_context.attr_captcha.getObjProperty('captchaSecret', zms_context.REQUEST)
		
		temp_chars		= 'abcdefghkmnopqrstuvwxyz'
		temp_chars		+= (temp_client != 'demo') and temp_chars.upper() + '0123456789' or ''
		
		self.id						= 'captchas.net'
		self.captcha			= CaptchasDotNet(temp_client, temp_secret, alphabet = temp_chars)
				
	def GetContent(self):
		temp_result = '<input type="hidden" name="captcha_random" value="%s" />'%self.captcha.random()
		temp_result += self.captcha.image() + '<br />' 
		temp_result += '<input type="submit" name="captcha_new" value="%s" /><br />'%self.zms_context.getLangStr('captchaNewCode', self.zms_lang)
		temp_result += '<label>%s</label><br />'%self.zms_context.getLangStr('captchaLabel', self.zms_lang)
		temp_result += '<input type="text" name="captcha_password" size="16" />'
		
		return temp_result
	
	def IsCodeValid(self):
		#check random string
		if (self.captcha.validate(self.zms_context.REQUEST.form.get('captcha_random', ''))):
			#check captcha password
			if (self.captcha.verify(self.zms_context.REQUEST.form.get('captcha_password', ''))):
				temp_result = (True, '')
			else:
				temp_result = (False, self.zms_context.getLangStr('captchaWrongVerification', self.zms_lang))
		else:
			temp_result = (False, self.zms_context.getLangStr('captchaInvalid', self.zms_lang))
			
		return temp_result

class C_PIL_Captcha(C_Captcha_Basic):
	def __init__(self, zms_context):
		C_Captcha_Basic.__init__(self, zms_context)
		
		self.id = 'PILCaptcha'
	
	def GetContent(self):
		temp_img = generateImage(self.zms_context.temp_folder, 
															self.zms_context.attr_captcha.getObjProperty('pilcaptchaCharCount', self.zms_context.REQUEST), 
															self.zms_context.attr_captcha.getObjProperty('pilcaptchaFontSize', self.zms_context.REQUEST),
															self.zms_context.REQUEST)
		
		temp_result = '<img src="%s" />'%temp_img.absolute_url() + '<br />' 
		temp_result += '<input type="submit" name="captcha_new" value="%s" /><br />'%self.zms_context.getLangStr('captchaNewCode', self.zms_lang)
		temp_result += '<label>%s</label><br />'%self.zms_context.getLangStr('captchaLabel', self.zms_lang)
		temp_result += '<input type="text" name="captcha_password" size="16" />'
		
		return temp_result
	
	def IsCodeValid(self):
		if (self.zms_context.REQUEST.SESSION['sess_captcha'] == self.zms_context.REQUEST.form.get('captcha_password', '')):
			temp_result = (True, '')
		else:
			temp_result = (False, self.zms_context.getLangStr('captchaWrongVerification', self.zms_lang))
		
		return temp_result

class C_ReCaptcha(C_Captcha_Basic):
	def __init__(self, zms_context):
		C_Captcha_Basic.__init__(self, zms_context)
		
		self.id = 'reCaptcha'
	
	def GetContent(self):
		temp_error = ''
		temp_result = displayhtml(self.zms_context.attr_captcha.getObjProperty('recaptchaPublicKey', self.zms_context.REQUEST), True, temp_error)
		
		print(temp_error)
		
		return temp_result
	
	def IsCodeValid(self):
		temp_result = False
		
		temp_response	= submit(self.zms_context.REQUEST.form.get('recaptcha_challenge_field', ''),
														self.zms_context.REQUEST.form.get('recaptcha_response_field', ''),
														self.zms_context.attr_captcha.getObjProperty('recaptchaPrivateKey', self.zms_context.REQUEST), 
														'127.0.0.1')
		
		if (temp_response.is_valid):
			temp_result = (True, '')
		else:
			#incorrect-captcha-sol
			if (temp_response.error_code == 'incorrect-captcha-sol'):
				temp_result = (False, self.zms_context.getLangStr('captchaWrongVerification', self.zms_lang))
			#invalid-site-private-key
			else:
				temp_result = (False, self.zms_context.getLangStr('captchaInvalid', self.zms_lang))
		
		return temp_result